﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/CpmContainerId.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_cpm_ts_msgs/msg/cpm_container_id.h"


#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__CPM_CONTAINER_ID__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__CPM_CONTAINER_ID__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cpm_ts_msgs__msg__CpmContainerId__MIN = 1
};

/// Constant 'MAX'.
enum
{
  etsi_its_cpm_ts_msgs__msg__CpmContainerId__MAX = 16
};

/// Constant 'ORIGINATING_RSU_CONTAINER'.
enum
{
  etsi_its_cpm_ts_msgs__msg__CpmContainerId__ORIGINATING_RSU_CONTAINER = 2
};

/// Constant 'ORIGINATING_VEHICLE_CONTAINER'.
enum
{
  etsi_its_cpm_ts_msgs__msg__CpmContainerId__ORIGINATING_VEHICLE_CONTAINER = 1
};

/// Constant 'PERCEIVED_OBJECT_CONTAINER'.
enum
{
  etsi_its_cpm_ts_msgs__msg__CpmContainerId__PERCEIVED_OBJECT_CONTAINER = 5
};

/// Constant 'PERCEPTION_REGION_CONTAINER'.
enum
{
  etsi_its_cpm_ts_msgs__msg__CpmContainerId__PERCEPTION_REGION_CONTAINER = 4
};

/// Constant 'SENSOR_INFORMATION_CONTAINER'.
enum
{
  etsi_its_cpm_ts_msgs__msg__CpmContainerId__SENSOR_INFORMATION_CONTAINER = 3
};

/// Struct defined in msg/CpmContainerId in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__CpmContainerId
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// CpmContainerId ::= INTEGER (1..16)
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DE represents the identifier of the container type.
  /// *
  uint8_t value;
} etsi_its_cpm_ts_msgs__msg__CpmContainerId;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__CpmContainerId.
typedef struct etsi_its_cpm_ts_msgs__msg__CpmContainerId__Sequence
{
  etsi_its_cpm_ts_msgs__msg__CpmContainerId * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__CpmContainerId__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__CPM_CONTAINER_ID__STRUCT_H_
