// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/CpmContainers.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_cpm_ts_msgs/msg/cpm_containers.hpp"


#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__CPM_CONTAINERS__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__CPM_CONTAINERS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'choice'
#include "etsi_its_cpm_ts_msgs/msg/detail/cpm_container_id__struct.hpp"
// Member 'originating_vehicle_container'
#include "etsi_its_cpm_ts_msgs/msg/detail/originating_vehicle_container__struct.hpp"
// Member 'originating_rsu_container'
#include "etsi_its_cpm_ts_msgs/msg/detail/originating_rsu_container__struct.hpp"
// Member 'sensor_information_container'
#include "etsi_its_cpm_ts_msgs/msg/detail/sensor_information_container__struct.hpp"
// Member 'perception_region_container'
#include "etsi_its_cpm_ts_msgs/msg/detail/perception_region_container__struct.hpp"
// Member 'perceived_object_container'
#include "etsi_its_cpm_ts_msgs/msg/detail/perceived_object_container__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__CpmContainers __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__CpmContainers __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct CpmContainers_
{
  using Type = CpmContainers_<ContainerAllocator>;

  explicit CpmContainers_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : choice(_init),
    originating_vehicle_container(_init),
    originating_rsu_container(_init),
    sensor_information_container(_init),
    perception_region_container(_init),
    perceived_object_container(_init)
  {
    (void)_init;
  }

  explicit CpmContainers_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : choice(_alloc, _init),
    originating_vehicle_container(_alloc, _init),
    originating_rsu_container(_alloc, _init),
    sensor_information_container(_alloc, _init),
    perception_region_container(_alloc, _init),
    perceived_object_container(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _choice_type =
    etsi_its_cpm_ts_msgs::msg::CpmContainerId_<ContainerAllocator>;
  _choice_type choice;
  using _originating_vehicle_container_type =
    etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer_<ContainerAllocator>;
  _originating_vehicle_container_type originating_vehicle_container;
  using _originating_rsu_container_type =
    etsi_its_cpm_ts_msgs::msg::OriginatingRsuContainer_<ContainerAllocator>;
  _originating_rsu_container_type originating_rsu_container;
  using _sensor_information_container_type =
    etsi_its_cpm_ts_msgs::msg::SensorInformationContainer_<ContainerAllocator>;
  _sensor_information_container_type sensor_information_container;
  using _perception_region_container_type =
    etsi_its_cpm_ts_msgs::msg::PerceptionRegionContainer_<ContainerAllocator>;
  _perception_region_container_type perception_region_container;
  using _perceived_object_container_type =
    etsi_its_cpm_ts_msgs::msg::PerceivedObjectContainer_<ContainerAllocator>;
  _perceived_object_container_type perceived_object_container;

  // setters for named parameter idiom
  Type & set__choice(
    const etsi_its_cpm_ts_msgs::msg::CpmContainerId_<ContainerAllocator> & _arg)
  {
    this->choice = _arg;
    return *this;
  }
  Type & set__originating_vehicle_container(
    const etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer_<ContainerAllocator> & _arg)
  {
    this->originating_vehicle_container = _arg;
    return *this;
  }
  Type & set__originating_rsu_container(
    const etsi_its_cpm_ts_msgs::msg::OriginatingRsuContainer_<ContainerAllocator> & _arg)
  {
    this->originating_rsu_container = _arg;
    return *this;
  }
  Type & set__sensor_information_container(
    const etsi_its_cpm_ts_msgs::msg::SensorInformationContainer_<ContainerAllocator> & _arg)
  {
    this->sensor_information_container = _arg;
    return *this;
  }
  Type & set__perception_region_container(
    const etsi_its_cpm_ts_msgs::msg::PerceptionRegionContainer_<ContainerAllocator> & _arg)
  {
    this->perception_region_container = _arg;
    return *this;
  }
  Type & set__perceived_object_container(
    const etsi_its_cpm_ts_msgs::msg::PerceivedObjectContainer_<ContainerAllocator> & _arg)
  {
    this->perceived_object_container = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::CpmContainers_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::CpmContainers_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::CpmContainers_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::CpmContainers_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::CpmContainers_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::CpmContainers_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::CpmContainers_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::CpmContainers_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::CpmContainers_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::CpmContainers_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__CpmContainers
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::CpmContainers_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__CpmContainers
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::CpmContainers_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CpmContainers_ & other) const
  {
    if (this->choice != other.choice) {
      return false;
    }
    if (this->originating_vehicle_container != other.originating_vehicle_container) {
      return false;
    }
    if (this->originating_rsu_container != other.originating_rsu_container) {
      return false;
    }
    if (this->sensor_information_container != other.sensor_information_container) {
      return false;
    }
    if (this->perception_region_container != other.perception_region_container) {
      return false;
    }
    if (this->perceived_object_container != other.perceived_object_container) {
      return false;
    }
    return true;
  }
  bool operator!=(const CpmContainers_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CpmContainers_

// alias to use template instance with default allocator
using CpmContainers =
  etsi_its_cpm_ts_msgs::msg::CpmContainers_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__CPM_CONTAINERS__STRUCT_HPP_
