// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/CpmContainers.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_cpm_ts_msgs/msg/cpm_containers.hpp"


#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__CPM_CONTAINERS__TRAITS_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__CPM_CONTAINERS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cpm_ts_msgs/msg/detail/cpm_containers__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'choice'
#include "etsi_its_cpm_ts_msgs/msg/detail/cpm_container_id__traits.hpp"
// Member 'originating_vehicle_container'
#include "etsi_its_cpm_ts_msgs/msg/detail/originating_vehicle_container__traits.hpp"
// Member 'originating_rsu_container'
#include "etsi_its_cpm_ts_msgs/msg/detail/originating_rsu_container__traits.hpp"
// Member 'sensor_information_container'
#include "etsi_its_cpm_ts_msgs/msg/detail/sensor_information_container__traits.hpp"
// Member 'perception_region_container'
#include "etsi_its_cpm_ts_msgs/msg/detail/perception_region_container__traits.hpp"
// Member 'perceived_object_container'
#include "etsi_its_cpm_ts_msgs/msg/detail/perceived_object_container__traits.hpp"

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const CpmContainers & msg,
  std::ostream & out)
{
  out << "{";
  // member: choice
  {
    out << "choice: ";
    to_flow_style_yaml(msg.choice, out);
    out << ", ";
  }

  // member: originating_vehicle_container
  {
    out << "originating_vehicle_container: ";
    to_flow_style_yaml(msg.originating_vehicle_container, out);
    out << ", ";
  }

  // member: originating_rsu_container
  {
    out << "originating_rsu_container: ";
    to_flow_style_yaml(msg.originating_rsu_container, out);
    out << ", ";
  }

  // member: sensor_information_container
  {
    out << "sensor_information_container: ";
    to_flow_style_yaml(msg.sensor_information_container, out);
    out << ", ";
  }

  // member: perception_region_container
  {
    out << "perception_region_container: ";
    to_flow_style_yaml(msg.perception_region_container, out);
    out << ", ";
  }

  // member: perceived_object_container
  {
    out << "perceived_object_container: ";
    to_flow_style_yaml(msg.perceived_object_container, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CpmContainers & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: choice
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "choice:\n";
    to_block_style_yaml(msg.choice, out, indentation + 2);
  }

  // member: originating_vehicle_container
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "originating_vehicle_container:\n";
    to_block_style_yaml(msg.originating_vehicle_container, out, indentation + 2);
  }

  // member: originating_rsu_container
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "originating_rsu_container:\n";
    to_block_style_yaml(msg.originating_rsu_container, out, indentation + 2);
  }

  // member: sensor_information_container
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sensor_information_container:\n";
    to_block_style_yaml(msg.sensor_information_container, out, indentation + 2);
  }

  // member: perception_region_container
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "perception_region_container:\n";
    to_block_style_yaml(msg.perception_region_container, out, indentation + 2);
  }

  // member: perceived_object_container
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "perceived_object_container:\n";
    to_block_style_yaml(msg.perceived_object_container, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CpmContainers & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cpm_ts_msgs::msg::CpmContainers & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cpm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cpm_ts_msgs::msg::CpmContainers & msg)
{
  return etsi_its_cpm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cpm_ts_msgs::msg::CpmContainers>()
{
  return "etsi_its_cpm_ts_msgs::msg::CpmContainers";
}

template<>
inline const char * name<etsi_its_cpm_ts_msgs::msg::CpmContainers>()
{
  return "etsi_its_cpm_ts_msgs/msg/CpmContainers";
}

template<>
struct has_fixed_size<etsi_its_cpm_ts_msgs::msg::CpmContainers>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cpm_ts_msgs::msg::CpmContainerId>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::OriginatingRsuContainer>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::PerceivedObjectContainer>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::PerceptionRegionContainer>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::SensorInformationContainer>::value> {};

template<>
struct has_bounded_size<etsi_its_cpm_ts_msgs::msg::CpmContainers>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cpm_ts_msgs::msg::CpmContainerId>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::OriginatingRsuContainer>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::PerceivedObjectContainer>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::PerceptionRegionContainer>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::SensorInformationContainer>::value> {};

template<>
struct is_message<etsi_its_cpm_ts_msgs::msg::CpmContainers>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__CPM_CONTAINERS__TRAITS_HPP_
