// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_cpm_ts_msgs:msg/PtActivationType.idl
// generated code does not contain a copyright notice

#include "etsi_its_cpm_ts_msgs/msg/detail/pt_activation_type__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cpm_ts_msgs
const rosidl_type_hash_t *
etsi_its_cpm_ts_msgs__msg__PtActivationType__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x0d, 0xd2, 0x10, 0x57, 0x35, 0x56, 0x86, 0x80,
      0xfe, 0x2a, 0xea, 0xa0, 0x9b, 0xa3, 0x44, 0x26,
      0xbe, 0xc7, 0xbd, 0x2b, 0x21, 0x11, 0xde, 0x43,
      0x2e, 0xe2, 0x06, 0xfb, 0x49, 0x6a, 0x9d, 0x88,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_cpm_ts_msgs__msg__PtActivationType__TYPE_NAME[] = "etsi_its_cpm_ts_msgs/msg/PtActivationType";

// Define type names, field names, and default values
static char etsi_its_cpm_ts_msgs__msg__PtActivationType__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_cpm_ts_msgs__msg__PtActivationType__FIELDS[] = {
  {
    {etsi_its_cpm_ts_msgs__msg__PtActivationType__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_cpm_ts_msgs__msg__PtActivationType__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_cpm_ts_msgs__msg__PtActivationType__TYPE_NAME, 41, 41},
      {etsi_its_cpm_ts_msgs__msg__PtActivationType__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# PtActivationType ::= INTEGER {\n"
  "#     undefinedCodingType (0), \n"
  "#     r09-16CodingType    (1), \n"
  "#     vdv-50149CodingType (2)\n"
  "# } (0..255)\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE indicates a certain coding type of the PtActivationData data.\n"
  "# *\n"
  "# * The folowing value are specified:\n"
  "# * - 0 `undefinedCodingType`  : undefined coding type,\n"
  "# * - 1 `r09-16CodingType`     : coding of PtActivationData conform to VDV recommendation 420 [7],\n"
  "# * - 2 `vdv-50149CodingType`  : coding of PtActivationData based on VDV recommendation 420 [7].\n"
  "# * - 3 - 255                  : reserved for alternative and future use.\n"
  "# * \n"
  "# * @category: Vehicle information \n"
  "# * @revision: V1.3.1\n"
  "# \n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 255\n"
  "uint8 UNDEFINED_CODING_TYPE = 0\n"
  "uint8 R09_16_CODING_TYPE = 1\n"
  "uint8 VDV_50149_CODING_TYPE = 2";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_cpm_ts_msgs__msg__PtActivationType__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_cpm_ts_msgs__msg__PtActivationType__TYPE_NAME, 41, 41},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2436, 2436},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_cpm_ts_msgs__msg__PtActivationType__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_cpm_ts_msgs__msg__PtActivationType__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
